include \masm32\include\masm32rt.inc

.data

Mydword	dd	5

SomeEqu	equ	9

; this macro is the same as print in macros.asm, but preserves all registers
debug macro args:vararg
	pushad
	% print args
	popad
endm

.code
start:
	push 4				; pushes 4
	push Mydword	; pushes 5 (contents of Mydword)
	mov Mydword, 6
	push Mydword	; pushes 6 (contents of Mydword)
	push SomeEqu	; pushes 9 (SomeEqu is replaced by 9 by the assembler)
	push offset Mydword	; pushes the address of Mydword (usually something like 004xxxxxh)
	
	push 16
	push LMEM_FIXED
	call LocalAlloc
	; because LocalAlloc popped two dwords on the stack, the address of Mydword is at the top of the stack
	
	mov dword ptr [eax], 0FFh
	push eax			; pushes the address of the memory we just allocated
	push dword ptr [eax]		; pushes 255 (the contents of [eax] = 0FFh = 255 decimal)
	
	push eax
	call LocalFree
	; LocalFree pops one dword, so the top of the stack contains 255
	
	; now let's print the contents of the stack (it's all printed in hex)
	pop eax
	debug "Pop 1: "
	debug <hex$(eax)>, 'h', 10
	
	pop eax
	debug "Pop 2: "
	debug <hex$(eax)>, 'h', 10
	
	pop eax
	debug "Pop 3: "
	debug <hex$(eax)>, 'h', 10
	
	pop eax
	debug "Pop 4: "
	debug <hex$(eax)>, 'h', 10
	
	pop eax
	debug "Pop 5: "
	debug <hex$(eax)>, 'h', 10
	
	pop eax
	debug "Pop 6: "
	debug <hex$(eax)>, 'h', 10
	
	pop eax
	debug "Pop 7: "
	debug <hex$(eax)>, 'h', 10
	
	inkey
	exit 0
	
end start
